/*
	Scripted by Shuubaru, contact: Shuubaru#3447
	
	Free to use/redistribute.
	
	Only tested in 14388 build.
	
	Usage:
		Hold ALT + arrows UP or DOWN to cycle between vehicles, they are ordered alphabetically.
*/

var VK_CTRL = 18;
var player = new Player(0);

var vehicles = [577, 445, 602, 416, 592, 424, 581, 481, 485, 607, 606, 568, 429, 433, 511, 499, 459, 509, 536, 496, 504, 422, 590, 498, 609, 401, 575, 518, 402, 541, 482, 431, 438, 457, 527, 483, 548, 524, 415, 542, 589, 437, 472, 532, 480, 512, 578, 473, 593, 486, 406, 573, 507, 562, 585, 427, 419, 587, 490, 528, 521, 462, 610, 533, 407, 544, 565, 455, 530, 526, 463, 537, 569, 466, 604, 492, 523, 474, 588, 434, 494, 503, 502, 425, 579, 545, 520, 411, 546, 559, 493, 508, 571, 400, 595, 417, 403, 517, 410, 484, 487, 551, 500, 444, 556, 557, 418, 510, 572, 423, 414, 522, 516, 553, 488, 582, 467, 461, 443, 470, 404, 603, 600, 448, 596, 598, 497, 599, 597, 413, 430, 426, 436, 547, 471, 441, 464, 594, 501, 465, 564, 563, 489, 505, 453, 479, 534, 432, 515, 442, 440, 476, 601, 475, 543, 605, 468, 495, 567, 447, 428, 405, 519, 460, 535, 458, 469, 452, 446, 580, 439, 561, 538, 570, 611, 409, 513, 560, 550, 506, 574, 566, 549, 514, 420, 576, 525, 531, 608, 584, 435, 450, 591, 449, 408, 454, 583, 451, 558, 552, 540, 491, 412, 539, 478, 421, 586, 529, 555, 456, 554, 477]
var vehicles_name = ["AT-400", "Admiral", "Alpha", "Ambulance", "Andromada", "BF Injection", "BF-400", "BMX", "Baggage", "Baggage Trailer (Uncovered)", "Baggage Trailer (covered)", "Bandito", "Banshee", "Barracks", "Beagle", "Benson", "Berkley's RC Van", "Bike", "Blade", "Blista Compact", "Bloodring Banger", "Bobcat", "Box Freight", "Boxville", "Boxville Mission", "Bravura", "Broadway", "Buccaneer", "Buffalo", "Bullet", "Burrito", "Bus", "Cabbie", "Caddy", "Cadrona", "Camper", "Cargobob", "Cement Truck", "Cheetah", "Clover", "Club", "Coach", "Coastguard", "Combine Harvester", "Comet", "Cropduster", "DFT-30", "Dinghy", "Dodo", "Dozer", "Dumper", "Dune", "Elegant", "Elegy", "Emperor", "Enforcer", "Esperanto", "Euros", "FBI Rancher", "FBI Truck", "FCR-900", "Faggio", "Farm Trailer", "Feltzer", "Fire Truck", "Fire Truck Ladder", "Flash", "Flatbed", "Forklift", "Fortune", "Freeway", "Freight", "Freight Train Flatbed", "Glendale", "Glendale Damaged", "Greenwood", "HPV1000", "Hermes", "Hotdog", "Hotknife", "Hotring Racer", "Hotring Racer 2", "Hotring Racer 3", "Hunter", "Huntley", "Hustler", "Hydra", "Infernus", "Intruder", "Jester", "Jetmax", "Journey", "Kart", "Landstalker", "Launch", "Leviathan", "Linerunner", "Majestic", "Manana", "Marquis", "Maverick", "Merit", "Mesa", "Monster 1", "Monster 2", "Monster 3", "Moonbeam", "Mountain Bike", "Mower", "Mr. Whoopee", "Mule", "NRG-500", "Nebula", "Nevada", "News Chopper", "Newsvan", "Oceanic", "PCJ-600", "Packer", "Patriot", "Perennial", "Phoenix", "Picador", "Pizzaboy", "Police LS", "Police LV", "Police Maverick", "Police Ranger", "Police SF", "Pony", "Predator", "Premier", "Previon", "Primo", "Quadbike", "RC Bandit", "RC Baron", "RC Cam", "RC Goblin", "RC Raider", "RC Tiger", "Raindance", "Rancher", "Rancher Lure", "Reefer", "Regina", "Remington", "Rhino", "Roadtrain", "Romero", "Rumpo", "Rustler", "S.W.A.T.", "Sabre", "Sadler", "Sadler Damaged", "Sanchez", "Sandking", "Savanna", "Seasparrow", "Securicar", "Sentinel", "Shamal", "Skimmer", "Slamvan", "Solair", "Sparrow", "Speeder", "Squalo", "Stafford", "Stallion", "Stratum", "Streak", "Streak Train Trailer", "Street Clean Trailer", "Stretch", "Stuntplane", "Sultan", "Sunrise", "Super GT", "Sweeper", "Tahoma", "Tampa", "Tanker", "Taxi", "Tornado", "Towtruck", "Tractor", "Trailer (Stairs)", "Trailer (Tanker Commando)", "Trailer 1", "Trailer 2", "Trailer 3", "Tram", "Trashmaster", "Tropic", "Tug", "Turismo", "Uranus", "Utility Van", "Vincent", "Virgo", "Voodoo", "Vortex", "Walton", "Washington", "Wayfarer", "Willard", "Windsor", "Yankee", "Yosemite", "ZR-350"]
var index = 0
var current_vehicle = false
var light_state = false
 
while (true) {
	wait(250);
	if (Pad.IsKeyPressed(VK_CTRL) && (Pad.IsKeyPressed(38) || Pad.IsKeyPressed(40)) && player.isPlaying()) { // is pressing CTRL and UP or DOWN arrows?
		if (current_vehicle != false) {
			// destroy the previously created vehicle, remove this line if you dont want to destroy it,
			// however new spawned cars could be spawned over the previous, so be sure they wont get stuck!
			current_vehicle.delete(); 
		}
		if (Pad.IsKeyPressed(38)) { // arrow UP to increase value
			index = index + 1;
		}
		else if (Pad.IsKeyPressed(40)) { // arrow DOWN to decrease value
			index = index - 1;
		}
		if (index > vehicles.length-1) {
			index = 0;
		}
		else if (index < 0) {
			index = vehicles.length-1;
		}
		var veh_name = vehicles_name[index]
		Text.Print(veh_name.slice(0,12), 500, 1) // large strings might crash the game, so I limited the vehicle names to 12 characters
		loadModel(vehicles[index]);
		var pos = player.getChar().getOffsetInWorldCoords(0, 8, 1); // spawn 8 meters in front of the player
		current_vehicle = Car.Create(vehicles[index], pos.x, pos.y, pos.z);
		current_vehicle.markAsNoLongerNeeded();
		current_vehicle.lockDoors(0); // force doors to be unlocked, some police/fbi/swat vehicles may spawn locked otherwise
		Streaming.MarkModelAsNoLongerNeeded(vehicles[index]);
	}
}

function loadModel(ModelID) {
	Streaming.RequestModel(ModelID);
	while (!Streaming.HasModelLoaded(ModelID)) {
		wait(250);
	}
}